from typing import Any

from .models import Response
from .sessions import _Data, _Params

def request(
    method: str | bytes,
    url: str | bytes,
    params: _Params | None = ...,
    data: Any | None = ...,
    headers: Any | None = ...,
    cookies: Any | None = ...,
    files: Any | None = ...,
    auth: Any | None = ...,
    timeout: Any | None = ...,
    allow_redirects: bool = ...,
    proxies: Any | None = ...,
    hooks: Any | None = ...,
    stream: Any | None = ...,
    verify: Any | None = ...,
    cert: Any | None = ...,
    json: Any | None = ...,
) -> Response: ...
def get(
    url: str | bytes,
    params: _Params | None = ...,
    data: Any | None = ...,
    headers: Any | None = ...,
    cookies: Any | None = ...,
    files: Any | None = ...,
    auth: Any | None = ...,
    timeout: Any | None = ...,
    allow_redirects: bool = ...,
    proxies: Any | None = ...,
    hooks: Any | None = ...,
    stream: Any | None = ...,
    verify: Any | None = ...,
    cert: Any | None = ...,
    json: Any | None = ...,
) -> Response: ...
def options(
    url: str | bytes,
    params: _Params | None = ...,
    data: Any | None = ...,
    headers: Any | None = ...,
    cookies: Any | None = ...,
    files: Any | None = ...,
    auth: Any | None = ...,
    timeout: Any | None = ...,
    allow_redirects: bool = ...,
    proxies: Any | None = ...,
    hooks: Any | None = ...,
    stream: Any | None = ...,
    verify: Any | None = ...,
    cert: Any | None = ...,
    json: Any | None = ...,
) -> Response: ...
def head(
    url: str | bytes,
    params: _Params | None = ...,
    data: Any | None = ...,
    headers: Any | None = ...,
    cookies: Any | None = ...,
    files: Any | None = ...,
    auth: Any | None = ...,
    timeout: Any | None = ...,
    allow_redirects: bool = ...,
    proxies: Any | None = ...,
    hooks: Any | None = ...,
    stream: Any | None = ...,
    verify: Any | None = ...,
    cert: Any | None = ...,
    json: Any | None = ...,
) -> Response: ...
def post(
    url: str | bytes,
    data: _Data = ...,
    json: Any | None = ...,
    params: _Params | None = ...,
    headers: Any | None = ...,
    cookies: Any | None = ...,
    files: Any | None = ...,
    auth: Any | None = ...,
    timeout: Any | None = ...,
    allow_redirects: bool = ...,
    proxies: Any | None = ...,
    hooks: Any | None = ...,
    stream: Any | None = ...,
    verify: Any | None = ...,
    cert: Any | None = ...,
) -> Response: ...
def put(
    url: str | bytes,
    data: _Data = ...,
    params: _Params | None = ...,
    headers: Any | None = ...,
    cookies: Any | None = ...,
    files: Any | None = ...,
    auth: Any | None = ...,
    timeout: Any | None = ...,
    allow_redirects: bool = ...,
    proxies: Any | None = ...,
    hooks: Any | None = ...,
    stream: Any | None = ...,
    verify: Any | None = ...,
    cert: Any | None = ...,
    json: Any | None = ...,
) -> Response: ...
def patch(
    url: str | bytes,
    data: _Data = ...,
    params: _Params | None = ...,
    headers: Any | None = ...,
    cookies: Any | None = ...,
    files: Any | None = ...,
    auth: Any | None = ...,
    timeout: Any | None = ...,
    allow_redirects: bool = ...,
    proxies: Any | None = ...,
    hooks: Any | None = ...,
    stream: Any | None = ...,
    verify: Any | None = ...,
    cert: Any | None = ...,
    json: Any | None = ...,
) -> Response: ...
def delete(
    url: str | bytes,
    params: _Params | None = ...,
    data: Any | None = ...,
    headers: Any | None = ...,
    cookies: Any | None = ...,
    files: Any | None = ...,
    auth: Any | None = ...,
    timeout: Any | None = ...,
    allow_redirects: bool = ...,
    proxies: Any | None = ...,
    hooks: Any | None = ...,
    stream: Any | None = ...,
    verify: Any | None = ...,
    cert: Any | None = ...,
    json: Any | None = ...,
) -> Response: ...
